#!/usr/bin/env python
#
#
#   Copyright (c) 2007 Jesse Guardiani <jesse@guardiani.us>
#
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License as
#   published by the Free Software Foundation; either version 2 of the
#   License, or (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
#   02111-1307, USA.
#

import pygame,os,gc
from pygame.locals import *


albumcache      = None
MAINFONTCOLOR   = None
MAINFONTBGCOLOR = None
initialized     = False
ISMAEMO         = False
osso_c          = None


def init_globals():
  global ISMAEMO, osso_c
  gc.disable() # don't let garbage collector ruin our frame rate
  #gc.set_debug(gc.DEBUG_LEAK)
  #
  # Init Pymp
  #
  HOME = os.path.expanduser("~/.kagu")

  if not os.access(HOME, os.F_OK | os.W_OK):
    os.mkdir(HOME)  #create prefs directory

  if os.name=="posix" and os.path.exists('/media/mmc1'): ISMAEMO=True
  if ISMAEMO:
    import osso
    osso_c = osso.Context("kagu", "1.0", False)

def gprint_ret(text,font_size=False,fg_color=False,bg_color=None):
  global MAINFONTCOLOR
  global MAINFONTBGCOLOR
  if not font_size: font_size = 36
  if not fg_color: fg_color = MAINFONTCOLOR
  #if not bg_color: bg_color = MAINFONTBGCOLOR
  font = pygame.font.Font(None,font_size)
  if bg_color: font_surf=font.render(text, True, fg_color, bg_color)
  else: font_surf=font.render(text, True, fg_color)
  return font_surf

def gprint(text,surface,point=(200,200),font_size=False,fg_color=False,bg_color=None):
  font_surf = gprint_ret(text,font_size,fg_color,bg_color)
  surface.blit(font_surf,point)


def get_path_list():
  path_a = ['/media/mmc1','/media/mmc2','/media/mmc3','/home/user/MyDocs/.sounds','/Volumes/OSX/iTunes']
  return path_a

def calc_db_dir():
  path_a = get_path_list()
  db_path = ''

  for path in path_a: # figure out where to store the DB
    if os.path.exists(path):
      db_dir = path
  if not db_dir: assert None # no music paths found
  return db_dir


if not initialized: init_globals()
